#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<doslib.h>
#include	"phantom.h"

#define KEYFLAG  1	/* <key> Toǂ */
#define SMTPFLAG 2	/* SMTPT[o[ݒ荀ڂTo */
#define MAILFLAG 4	/* Mailݒ荀ڂTo */
#define NAMEFLAG 8	/* [U[  */
#define HOSTFLAG 16	/* zXg  */

static void clr_queue (struct _mqueue *q);
static int readsign (struct _mqueue *q, char *filename);
static int mkdir (char *str);
static void chkdir (char *str);
static void getenvdir (char *dest, char *envname);


static int readsign (struct _mqueue *q, char *filename)
{
	FILE *fp;
	char *r, *w;
	char buf[STR_LEN];
	char jisbuf[STR_LEN];

	r = filename;
	if (filename[0] == '~') {
		strcpy (buf, q->home);
		r++;
		if (*r == '/' || *r == '\\')	r++;
	} else {
		buf[0] = '\0';
	}
	strcat (buf, r);

	fp = fopen (buf, "rt");
	if (!fp) {
		fprintf (stdout, "t@C %s ܂\n", buf);
		return FALSE;
	}

	w = q->signature;
	while (fgets (buf, sizeof(buf), fp)) {
		sjis2jis (jisbuf, buf);
		r = jisbuf;
		while (*r) {
			*w++ = *r++;
			if (w - q->signature >= STR_LEN) {
				fputs ("t@C傫܂\n", stdout);
				fclose (fp);
				return FALSE;
			}
		}
	}
	*w = '\0';

	fclose(fp);
	q->putsign = TRUE;
	return TRUE;
}

static int mkdir (char *str)
{
	int drive = CURDRV ();
	int ret = TRUE;
	char *ptr;
	char dirname[FILE_LEN];
	struct FILBUF files_buf;

	ptr = strcpy (dirname, str);
	if (ptr[0] && ptr[1] == ':') {
		if (CHGDRV (ptr[0] - 'A') < 0)	return FALSE;
		ptr += 2;
	}

	if (*ptr == '\\')	ptr++;
	while (*ptr) {
		if (*ptr == '\\') {
			*ptr = '\0';
			if (FILES (&files_buf, dirname, 0x10) < 0) {
				if (MKDIR (dirname) < 0) {
					ret = FALSE;
					break;
				}
				if (Verbose) {
					fprintf (stdout, "%s 쐬܂\n", dirname);
				}
			}
			*ptr = '\\';
		}
		ptr++;
	}
	CHGDRV (drive);
	return ret;
}

static void chkdir (char *str)
{
	int found;
	int last = strlen (str);
	struct FILBUF files_buf;

	if (!last)	return;

	str[last - 1] = '\0';
	found = FILES (&files_buf, str, 0x10);
	str[last - 1] = '\\';
	str[last] = '\0';

	if (found < 0) {
		if (Verbose) {
			fprintf (stdout, "%s ݂܂\n", str);
		}
		if (!mkdir (str)) {
			fprintf (stdout, "fBNg %s 쐬ł܂\n",
				str);
			exit (-5);
		}
	}
}

/* smail.rc JAKvȏEĂ */
int Get_SmailRc(struct _mqueue *q)
{
	FILE *fp;
	char *ptr;
	char flag = 0;
	char matchkey[SET_LEN];
	char TempStr[STR_LEN];

	/* smail.rc TĊJ */
	/* ܂ SMAIL_CONFIG */
	ptr = getenv ("SMAIL_CONFIG");
	if (ptr) {
		fp = fopen (ptr, "rt");
		if (!fp) {
			fputs ("ϐSMAIL_CONFIĜt@C݂܂łB\n",
				stdout);
			exit (-6);
		}
		if (Verbose) {
			fprintf (stdout, "%s ܂\n", ptr);
		}
	} else {
		if (!q->home[0]) {
			fputs ("smail.rc ̈ʒuݒ肵ĂB\n", stdout);
			exit (-7);
		}

		/*  HOME/smail.rc */
		sprintf (TempStr, "%ssmail.rc", q->home);
		fp = fopen (TempStr, "rt");
		if (!fp) {

			/* Ō HOME/.smailrc */
			sprintf (TempStr, "%s.smailrc", q->home);
			fp = fopen (TempStr, "rt");
			if (!fp) {
				fputs ("phatom2 : smail.rc ܂B\n", stdout);
				exit (-8);
			}
		}
		if (Verbose) {
			fprintf (stdout, "%s ܂\n", TempStr);
		}
	}

	sprintf (matchkey, "!%s\n", q->Key);

	/* smail.rc L[To */
	while (fgets (TempStr, sizeof(TempStr), fp)) {
		if (!strcmpi (TempStr, matchkey)) {
			/* TĂuCN */
			flag = KEYFLAG;
			if (Verbose) {
				fprintf (stdout, "L[<%s>ǂݍ݂܂\n", q->Key);
			}
			break;
		}
	}

	if (!flag) {
		fprintf (stdout, "L[<%s>܂łB\n",
				matchkey);
		exit(-9);
	}

	/* SMTPzXgƃ[AhXTo */
	while (fgets (TempStr, sizeof(TempStr), fp)) {
		/* sŃL[̏I[Ƃ݂Ȃ */
		if (TempStr[0] == '\n')	break;

		if (TempStr[0] == '#')	continue;

		if (ptr = GetKeyword(TempStr, "MAIL:")) {
			/* mail ̌o */
			strcpy(q->MailAdress, ptr);
			flag |= MAILFLAG;

		} else if (ptr = GetKeyword(TempStr, "NAME:")) {
			/* name ̌o */
			sprintf (q->MailName, "\"%s\" ", ptr);

		} else if (ptr = GetKeyword(TempStr, "HOST:")) {
			/* host ̌o */
			q->HostName[0] = '@';
			strcpy (q->HostName + 1, ptr);

		} else if (ptr = GetKeyword(TempStr, "SIGNATURE:")) {
			/* signature ̌o */
			if (q->putsign != FALSE) {
				if (!readsign (q, ptr))	exit (-11);
			}
		}
	}

	while (fgets (TempStr, sizeof(TempStr), fp)) {
		if (TempStr[0] == '#')	continue;

		if (ptr = GetKeyword(TempStr, "DATE:")) {
			/* Date: t邩 */
			if (strcmpi (ptr, "ON")) {
				q->putdate = FALSE;
			}

		} else if (ptr = GetKeyword(TempStr, "MESSAGE_ID:")) {
			/* Message-ID: t邩 */
			if (strcmpi (ptr, "ON")) {
				q->putmesid = FALSE;
			}

		} else if (ptr = GetKeyword(TempStr, "SIGNATURE:")) {
			/* signature ̌o */
			if (q->putsign != FALSE) {
				if (!readsign (q, ptr))	exit (-11);
			}
		}
	}

	fclose(fp);

	/* G[\h */
	if (flag != (KEYFLAG|MAILFLAG)) {
		fprintf (stdout, "ݒt@C̃L[<%s> mail ڂ܂\n",
				q->Key);
		exit(-10);
	}

	strcat (q->qdir, q->Key);
	strcat (q->qdir, "\\");
	chkdir (q->qdir);

	q->Key[0] = '\0';
	return TRUE;
}

int add_queue (struct _mqueue *q, char *str, int mode)
{
	struct _sendfile *child, *parent;

	child = malloc (sizeof(struct _sendfile) + strlen(str));
	if (!child)	return FALSE;

	child->next = NULL;
	child->complete = mode;
	strcpy(child->line, str);

	if (q->head) {
		parent = q->head;
		while (parent->next) {
			parent = parent->next;
		}
		parent->next = child;
	} else {
		q->head = child;
	}
	q->entry++;
	return TRUE;
}

int indirect_queue (struct _mqueue *q, char *filename)
{
	int	ret = TRUE;
	FILE *fp;
	char buf[STR_LEN];

	strcpy(q->indirect, filename);
	fp = fopen (q->indirect, "rt");
	if (!fp) {
		fprintf (stdout, "Ԑڃt@C %s ǂ߂܂\n",
				q->indirect);
		return FALSE;
	}

	if (Verbose) {
		fprintf (stdout, "Ԑڃt@C %s ǂł܂\n",
				q->indirect);
	}

	while (fgets (buf, sizeof(buf), fp)) {
		if (buf[0] && buf[1] == ' ') {
			if (!add_queue (q, buf + 2, MULTI)) {
				fputs ("܂\n", stdout);
				ret = FALSE;
				break;
			}
		}
	}
	fclose (fp);
	return ret;
}

static void clr_queue (struct _mqueue *q)
{
	struct _sendfile *child, *parent;

	parent = q->head;
	while (parent) {
		child = parent->next;
		free (parent);
		parent = child;
	}
	q->entry = 0;
	q->head = NULL;
}

int destroy_queue (struct _mqueue *q)
{
	FILE *fp = NULL;
	struct _sendfile *parent;

	if (q->indirect[0]) {
		fp = fopen (q->indirect, "wt");
		if (fp) {
			if (Verbose) {
				fprintf (stdout, "Ԑڃt@C %s o͂Ă܂\n",
						q->indirect);
			}
			parent = q->head;
			while (parent) {
				if (parent->complete != SINGLE) {
					fprintf (fp, "%c %s", parent->complete + '0',
							parent->line);
					parent = parent->next;
				}
			}
			fclose (fp);
		} else {
			fprintf (stdout, "Ԑڃt@C %s ɏ߂܂\n",
					q->indirect);
		}
	}
	clr_queue (q);
	free (q);

	return (int)fp;
}

static void getenvdir (char *dest, char *envname)
{
	char *r, *w = dest;

	if (r = getenv (envname)) {
		while (*r) {
			if (*r == '/') {
				*w++ = '\\';
				r++;
			} else {
				*w++ = *r++;
			}
		}
		if (w != dest && w[-1] != '\\')	*w++ = '\\';
	}
	*w = '\0';
}

struct _mqueue *create_queue ()
{
	struct _mqueue *q;

	q = malloc (sizeof(struct _mqueue));
	if (!q) {
		fputs ("܂\n", stdout);
		return NULL;
	}

	getenvdir (q->qdir, "MAILQUEUE");
	if (!q->qdir[0]) {
		fputs ("ϐ MAILQUEUE ݒ肳Ă܂", stdout);
		free (q);
		return NULL;
	}
	chkdir (q->qdir);

	getenvdir (q->home, "HOME");

	q->head = NULL;
	q->entry = 0;
	q->newfile = 0;
	q->putdate = TRUE;
	q->putmesid = TRUE;
	q->putsign = UNDECIDED;

	q->indirect[0] = '\0';
	strcpy (q->Key, "default-smtp");
	q->HostName[0] = '\0';
	q->MailName[0] = '\0';

	return q;
}
