#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "phantom.h"

static int serial;

static char *GetNewName(struct _mqueue *q);
static int write_queue (struct _mqueue *q, char *mailfile);


/* fBNgŎgĂȂt@C쐬 */
static char *GetNewName(struct _mqueue *q)
{
	FILE	*fp;
	static char	OpenTestName[FILE_LEN];

	/* Vt@C𔭌܂ő */
	while (TRUE) {
		sprintf (OpenTestName, "%s%d", q->qdir, q->newfile);

		/* `FbN...t@CȂ΂nj */
		if (!(fp = fopen(OpenTestName, "rt")))	return OpenTestName;

		/* t@CΌJԂ */
		fclose (fp);
		q->newfile++;
	}
}

/* Vt@C쐬A From ݒs */
static int write_queue (struct _mqueue *q, char *mailfile)
{
	FILE *infp, *outfp;
	char *ptr;
	char *NewFile;			/* Vt@C */
	char From[STR_LEN];		/* Froms */
	char jisbuf[STR_LEN];
	char TempStr[STR_LEN];	/* G[̏ȂǂɎgobt@ */
	char ToFlag = FALSE;	/* 悪邩ǂ */
	char MesIDFlag = !q->putmesid;	/* Message-ID邩ǂ */
	time_t nowtime;
	struct tm tm_time;

	/* Froms */
	sprintf (From, "From: %s<%s>\n",
			q->MailName, q->MailAdress);
	sjis2jis (jisbuf, From);
	jis2mimeB (From, jisbuf);

	infp = fopen (mailfile, "rt");
	if (!infp) {
		fprintf (stdout,
				"[t@C %s I[vł܂\n",
				mailfile);
		exit (-1);
	}

	/* o̓t@C𓾂 */
	NewFile = GetNewName (q);

	outfp = fopen (NewFile, "wt");
	if (!outfp) {
		fprintf (stdout, "%s 쐬ł܂\n", NewFile);
		exit (-2);
	}

	/* JԂ(MIMEwb_) */
	while (fgets822a (TempStr, sizeof(TempStr), infp)) {
		if (ptr = GetKeyword (TempStr, "TO:")) {
			ToFlag = *ptr;
			strcat (TempStr, "\n");
		} else if (ptr = GetKeyword (TempStr, "CC:")) {
			if (!*ptr)	continue;
			strcat (TempStr, "\n");
		} else if (!MesIDFlag
				&& (ptr = GetKeyword (TempStr, "MESSAGE-ID:"))) {
			MesIDFlag = TRUE;
			strcat (TempStr, "\n");
		}
		sjis2jis (jisbuf, TempStr);
		jis2mimeB (TempStr, jisbuf);
		fputs (TempStr, outfp);
	}

	if (!ToFlag) {
		fprintf (stdout,
				"[t@C %s Ɉw肪܂\n",
				mailfile);
		fclose (outfp);
		fclose (infp);
		remove (NewFile);
		return FALSE;
	}

	fputs (From, outfp);

	if (q->putdate) {
		time(&nowtime);
		tm_time = *localtime(&nowtime);
		strftime(TempStr, sizeof(TempStr), "%a, %d %b %Y %X", &tm_time);
		fprintf (outfp, "Date: %s +900 (JST)\n", TempStr);
	}
	if (!MesIDFlag) {
		fprintf (outfp, "Message-Id: <%4.4d%2.2d%2.2d%2.2d%2.2d%2.2d%4.4d.phantom2%s>\n",
				tm_time.tm_year + 1900, tm_time.tm_mon + 1, tm_time.tm_mday,
				tm_time.tm_hour, tm_time.tm_min, tm_time.tm_sec,
				serial++, q->HostName);
	}

	fputs ("MIME-Version: 1.0\n", outfp);
	fputs ("X-Mailer: phantom2 ver 0.10 X68k\n", outfp);
	fputs ("Content-Type: text/plain; charset=ISO-2022-JP\n", outfp);
	fputs ("Content-Transfer-Encoding: 7bit\n", outfp);
	fputc ('\n', outfp);

	/* JԂ({) */
	while (fgets (TempStr, sizeof(TempStr), infp)) {
		sjis2jis (jisbuf, TempStr);
		fputs (jisbuf, outfp);
	}

	/* t@C̓eo */
	if (q->putsign == TRUE)	fputs (q->signature, outfp);

	/* OϏ */
	strcpy (mailfile, NewFile);
	q->newfile++;

	fclose (outfp);
	fclose (infp);

	return TRUE;
}

/* [ϊo */
void SendMail (struct _mqueue *q)
{
	struct _sendfile *parent = q->head;
	char *r, *w, mailfile[FILE_LEN];

	serial = 0;

	while (parent) {
		r = parent->line;
		w = mailfile;
		while (*r && *r > ' ')	*w++ = *r++;
		*w = '\0';

		if (write_queue (q, mailfile)) {
			if (Verbose) {
				fprintf (stdout, "%s o͂܂\n",
						mailfile);
			}
			parent->complete = TRUE;
		}
		parent = parent->next;
	}
}
